# Residential Proxies

Operations for residential proxies

## POST /user/api/orders/{id}/add-bandwidth

> Purchase additional traffic (Residential)

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}},"schemas":{"AddBandwidthRequest":{"type":"object","properties":{"amount":{"type":"integer","description":"Amount in GB"},"promo_code":{"type":"string","nullable":true}},"required":["amount"]},"ApiSuccess":{"type":"object","properties":{"success":{"type":"boolean"}},"required":["success"]}}},"paths":{"/user/api/orders/{id}/add-bandwidth":{"post":{"tags":["Residential Proxies"],"summary":"Purchase additional traffic (Residential)","parameters":[{"in":"path","name":"id","required":true,"schema":{"type":"integer"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddBandwidthRequest"}}}},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiSuccess"}}}}}}}}}
```

## GET /user/api/proxies/sub-users

> Sub-user list

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}}},"paths":{"/user/api/proxies/sub-users":{"get":{"tags":["Residential Proxies"],"summary":"Sub-user list","parameters":[{"in":"query","name":"proxy_type","required":true,"description":"Proxy type (standart | premium)","schema":{"type":"string"}},{"in":"query","name":"offset","required":false,"schema":{"type":"integer"}},{"in":"query","name":"limit","required":false,"schema":{"type":"integer"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean"},"data":{"type":"array","items":{"type":"object","properties":{"user_id":{"type":"string"},"first_name":{"type":"string"},"proxy_password":{"type":"string"},"data":{"type":"integer"},"data_spent":{"type":"integer"}},"required":["user_id","first_name","proxy_password","data","data_spent"]}}}}}}}}}}}}
```

## GET /user/api/proxies/sub-user/{user\_id}

> Get sub-user by ID

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}}},"paths":{"/user/api/proxies/sub-user/{user_id}":{"get":{"tags":["Residential Proxies"],"summary":"Get sub-user by ID","parameters":[{"in":"path","name":"user_id","required":true,"schema":{"type":"string"}},{"in":"query","name":"proxy_type","required":true,"description":"Proxy type (standart | premium)","schema":{"type":"string"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean"},"data":{"type":"array","items":{"type":"object","properties":{"user_id":{"type":"string"},"first_name":{"type":"string"},"proxy_password":{"type":"string"},"data":{"type":"integer"},"data_spent":{"type":"integer"}},"required":["user_id","first_name","proxy_password","data","data_spent"]}}}}}}}}}}}}
```

## DELETE /user/api/proxies/sub-user/{user\_id}

> Delete sub-user

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}}},"paths":{"/user/api/proxies/sub-user/{user_id}":{"delete":{"tags":["Residential Proxies"],"summary":"Delete sub-user","parameters":[{"in":"path","name":"user_id","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean"},"data":{"type":"object"}}}}}}}}}}}
```

## PATCH /user/api/proxies/sub-user/{user\_id}

> Edit sub-user (name/package)

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}},"schemas":{"EditSubUserPayload":{"type":"object","properties":{"name":{"type":"string"}},"required":["name"]}}},"paths":{"/user/api/proxies/sub-user/{user_id}":{"patch":{"tags":["Residential Proxies"],"summary":"Edit sub-user (name/package)","parameters":[{"in":"path","name":"user_id","required":true,"schema":{"type":"string"}},{"in":"query","name":"proxy_type","required":true,"description":"Proxy type (standart | premium)","schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/EditSubUserPayload"}}}},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean"},"data":{"type":"object"}}}}}}}}}}}
```

## POST /user/api/proxies/sub-user

> Create sub-user

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}}},"paths":{"/user/api/proxies/sub-user":{"post":{"tags":["Residential Proxies"],"summary":"Create sub-user","parameters":[{"in":"query","name":"proxy_type","required":true,"description":"Proxy type (standart | premium)","schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"name":{"type":"string"},"data":{"type":"integer"}},"required":["name","data"]}}}},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean"},"data":{"type":"array","items":{"type":"object","properties":{"user_id":{"type":"string"},"first_name":{"type":"string"},"proxy_password":{"type":"string"},"data":{"type":"integer"},"data_spent":{"type":"integer"}},"required":["user_id","first_name","proxy_password","data","data_spent"]}}}}}}}}}}}}
```

## POST /user/api/proxies/sub-user/{user\_id}/data/add

> Add traffic to sub-user

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}}},"paths":{"/user/api/proxies/sub-user/{user_id}/data/add":{"post":{"tags":["Residential Proxies"],"summary":"Add traffic to sub-user","parameters":[{"in":"path","name":"user_id","required":true,"schema":{"type":"string"}},{"in":"query","name":"proxy_type","required":true,"description":"Proxy type (standart | premium)","schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"integer","description":"Amount in GB"}},"required":["data"]}}}},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean"},"data":{"type":"object"}}}}}}}}}}}
```

## POST /user/api/proxies/sub-user/{user\_id}/data/subtract

> Subtract traffic from sub-user

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}}},"paths":{"/user/api/proxies/sub-user/{user_id}/data/subtract":{"post":{"tags":["Residential Proxies"],"summary":"Subtract traffic from sub-user","parameters":[{"in":"path","name":"user_id","required":true,"schema":{"type":"string"}},{"in":"query","name":"proxy_type","required":true,"description":"Proxy type (standart | premium)","schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"integer","description":"Amount in GB"}},"required":["data"]}}}},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean"},"data":{"type":"object"}}}}}}}}}}}
```

## POST /user/api/proxies/sub-user/{user\_id}/password

> Change sub-user password

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}}},"paths":{"/user/api/proxies/sub-user/{user_id}/password":{"post":{"tags":["Residential Proxies"],"summary":"Change sub-user password","parameters":[{"in":"path","name":"user_id","required":true,"schema":{"type":"string"}},{"in":"query","name":"proxy_type","required":true,"description":"Proxy type (standart | premium)","schema":{"type":"string"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean"},"data":{"type":"object"}}}}}}}}}}}
```

## GET /user/api/proxies/countries

> Country list

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}},"schemas":{"PagedCountriesResponse":{"type":"object","properties":{"count":{"type":"integer"},"results":{"type":"array","items":{"$ref":"#/components/schemas/Country"}}},"required":["count","results"]},"Country":{"type":"object","properties":{"code":{"type":"string","maxLength":10,"description":"ISO country code"},"name":{"type":"string","maxLength":255,"description":"Country name"}},"required":["code","name"]}}},"paths":{"/user/api/proxies/countries":{"get":{"tags":["Residential Proxies"],"summary":"Country list","parameters":[{"in":"query","name":"proxy_type","required":true,"description":"Proxy type (standart | premium)","schema":{"type":"string"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PagedCountriesResponse"}}}}}}}}}
```

## GET /user/api/proxies/regions

> Region list

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}},"schemas":{"PagedRegionsResponse":{"type":"object","properties":{"count":{"type":"integer"},"results":{"type":"array","items":{"$ref":"#/components/schemas/Region"}}},"required":["count","results"]},"Region":{"type":"object","properties":{"code":{"type":"string","maxLength":10,"description":"Region code (state/province code)"},"name":{"type":"string","maxLength":255,"description":"Region name (state/province name)"},"country":{"$ref":"#/components/schemas/Country"}},"required":["code","name","country"]},"Country":{"type":"object","properties":{"code":{"type":"string","maxLength":10,"description":"ISO country code"},"name":{"type":"string","maxLength":255,"description":"Country name"}},"required":["code","name"]}}},"paths":{"/user/api/proxies/regions":{"get":{"tags":["Residential Proxies"],"summary":"Region list","parameters":[{"in":"query","name":"proxy_type","required":true,"description":"Proxy type (standart | premium)","schema":{"type":"string"}},{"in":"query","name":"country_code","required":true,"description":"ISO country code","schema":{"type":"string"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PagedRegionsResponse"}}}}}}}}}
```

## GET /user/api/proxies/cities

> City list

```json
{"openapi":"3.0.3","info":{"title":"ProxyShard User API Billing","version":"1.0.0"},"tags":[{"name":"Residential Proxies","description":"Operations for residential proxies"}],"servers":[{"url":"https://user-api.proxyshard.com"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer"}},"schemas":{"PagedCitiesResponse":{"type":"object","properties":{"count":{"type":"integer"},"results":{"type":"array","items":{"$ref":"#/components/schemas/City"}}},"required":["count","results"]},"City":{"type":"object","properties":{"code":{"type":"string","maxLength":50,"description":"City code (usually slug format)"},"name":{"type":"string","maxLength":255,"description":"City name"},"country":{"$ref":"#/components/schemas/Country"},"region":{"type":"object","nullable":true,"properties":{"code":{"type":"string","maxLength":10,"description":"Region code"},"name":{"type":"string","maxLength":255,"description":"Region name"}},"required":["code","name"]}},"required":["code","name","country"]},"Country":{"type":"object","properties":{"code":{"type":"string","maxLength":10,"description":"ISO country code"},"name":{"type":"string","maxLength":255,"description":"Country name"}},"required":["code","name"]}}},"paths":{"/user/api/proxies/cities":{"get":{"tags":["Residential Proxies"],"summary":"City list","parameters":[{"in":"query","name":"proxy_type","required":true,"description":"Proxy type (standart | premium)","schema":{"type":"string"}},{"in":"query","name":"country_code","required":true,"description":"ISO country code","schema":{"type":"string"}},{"in":"query","name":"region_code","required":true,"description":"Region code (state/province code)","schema":{"type":"string"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PagedCitiesResponse"}}}}}}}}}
```
